How many Complete Graph present in given undirected Graph? - graph

Is there a known algorithm to find all complete sub-graphs within a graph? I have an undirected, graph and I need to find all complete graphs present in that undirected graph.
Is there an existing algorithm for this?

Finding the number of complete subgraphs in an undirected graph is known as the clique problem. It is not solvable in polynomial time, since the number of complete subgraphs itself might be exponential. Therefore, there is not an algorithm that will solve this for graphs of any size in a reasonable amount of time. However, here is one I found that should work for small graphs:
https://en.wikipedia.org/wiki/Bron%E2%80%93Kerbosch_algorithm

Related

algorithm for 'generalized' matching in complete graphs

My problem is a generalization of a task solved by [Blossom algorithm] by Edmonds. The original task is the following: given a complete graph with weighted undirected edges, find a set of edges such that
1) every vertex of the graph is adjacent to only one edge from this set (i.e. vertices are grouped into pairs)
2) sum over weights of edges in this set is minimal.
Now, I would like to modify the first goal into
1') vertices are grouped into sets of 3 vertices (or in general, d vertices), and leave condition 2) unchanged.
My questions:
Do you know if this 'generalised' problem has a name?
Do you know about an algorithm solving it in number of steps being polynomial of number of vertices (like Blossom algorithm for an original problem)? I don't see a straightforward generalisation of Blossom algorithm, as it is based on looking for augmenting paths on a graph compressed to a bipartite graph (and uses here Hungarian algorithm). But augmenting paths do not seem to point to groups of vertices different than pairs.
Best regards,
Paweł

How to find the maximum Eulerian sub-graph in an un-directed given graph?

Given the next graph:
How do i find the maximum Eulerian sub-graph?
The correct answer should be this one (sub-graph with blue edges):
is there any algorithm to archive this? at least for small graphs like this one.

how to find the original directed graph?

I was thinking on a homework question given to me, it is as follows:
If you are given with a BFS and DFS traversal of a directed( or un-directed graph),
how would you find the original graph ?
Is it possible in either case?
thankyou
If I understand it correctly, it is not possible, since BFS and DFS produce a tree, and tree has |V|-1 edges. So, in these two trees you have at most 2|V|-2 different edges, and original graph can have up to |V|(|V|-1) edges for directed, and |V|(|V|-1)/2 for undirected graph.

complexity of printing all possible paths on a graph

In an undirected, unweighted graph, and I'm trying to print (store in file) all possible connecting paths between given 2 vertices on the graph, not including cycles.
when you consider a complete graph this problem is a NP-complete. because there are "(V-2)!" different paths between 2 vertices.
However,seems it is possible to do it with one of graph traversal (DFS-BFS) algorithm with time complexity of O(|V|+|E|) which is pretty polynomial.
I got confuse about solving a NP-Complete problem in polynomial time?
any idea about what is missing here ?
If you want all possible paths, and the graph has V vertices, and E edges, then the number of paths will be dependent upon the number of connects. Consider a fully connected graph, where every point connects to every other point. Then there are (v-2)! possible paths, right? Well (v-2)! > V+E (much greater).

Code for Vertex-Disjoint Menger Problem in NON-planar graphs

I am doing an EDA-analysis program. Reading some articles I have found that my problem has a name (Vertex-Disjoint Menger Problem). But all the articles describes algorithms for planar graphs - needless to say that I have non-planar undirected graphs.
This problem is equivalent to finding the minimum s-t vertex cut in a undirected graph.
Also, instead of high-level algorithmic descriptions, I would like functional C/C++ code. As far as I can tell, BOOST has no such functionality.
As mentioned in another question, finding the minimum s–t vertex cut in a undirected graph can be reduced to finding the minimum s–t edge cut in a directed graph, for which many algorithms and implementations exist.

Resources